%define appdir  %{_datadir}/%{name}
%define section free

Name:           argouml
Version:        0.14
Release:        1jpp
Epoch:          0
Summary:        A UML design tool with cognitive support
License:        BSD
URL:            http://argouml.tigris.org
Group:          Development
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://argouml.tigris.org/files/documents/4/0/argouml-0.14/ArgoUML-0.14-src.tar.gz
Source1:        %{name}-script
Source2:        %{name}-icon-16.png
Source3:        %{name}-icon-32.png
Source4:        %{name}-icon-48.png
Source5:        %{name}.desktop
Patch0:         %{name}-build.patch
Patch1:         %{name}-properties.patch
Requires:       antlr, dresden-ocl-argo, gef >= 0:0.9.6, log4j, nsuml
Requires:       jpackage-utils >= 0:1.5, xml-commons-apis, i18n-lib
BuildRequires:  ant, antlr, dresden-ocl-argo, gef >= 0:0.9.6, log4j, nsuml
BuildRequires:  xml-commons-apis, i18n-lib, jpackage-utils >= 0:1.5
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Obsoletes:      %{name}-rhmenu

%description
The goal of the ArgoUML project is to build an object oriented design
tool that is:
- A joy to use (we really mean it),
- Actually helpful to designers when they are making design decisions,
- Completely open source Java,
- Leading edge (supports the latest UML specifications),
- Modular and extensible,
- Integrated with the web and other Tigris tools.

%package        mdkmenu
Summary:        Mandrake menu entry for ArgoUML
Group:          Development
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    mdkmenu
%{summary}.

%package        legacymenu
Summary:        Legacy menu entry for ArgoUML
Group:          Text Editors/Integrated Development Environments (IDE)
Requires:       %{name} = %{epoch}:%{version}-%{release}
Conflicts:      redhat-menus

%description    legacymenu
%{summary}.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.


%prep
%setup -q -c
%patch0 -p0
%patch1 -p0
perl -pi -e \
  's|File=.*|File=\${user.home}/.argouml/argouml.log|' \
  src_new/org/argouml/resource/*.lcf
# remove binary files
find . -name "*.jar" -exec rm -f {} \;
# clean up manifest
perl -pi -e 's|^Class-Path.*$||s' src_new/templates/manifest.template


%build
export CLASSPATH=$(build-classpath \
antlr dresden-ocl-argo gef log4j nsuml xml-commons-apis i18n-lib)
ant -buildfile src_new/build.xml -Dbuild.compiler=modern jar prepare-docs


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -D -p -m 644 build/%{name}.jar $RPM_BUILD_ROOT%{appdir}/lib/%{name}.jar

# scripts
install -D -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/argouml

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# mdk menu entry
install -p -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\\
command="%{_bindir}/%{name}"\\
needs="X11"\\
icon="%{name}.png"\\
section="Applications/Development/Development environments"\\
title="ArgoUML" \
longtitle="A UML design tool with cognitive support"
EOF

# mdk icons
install -D -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png 
install -D -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png 
install -D -p -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png

# freedesktop.org menu entry
install -D -p -m 644 %{SOURCE5} \
  $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}.desktop

# icons for freedesktop.org and legacy menu entries
install -D -p -m 644 %{SOURCE2} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -D -p -m 644 %{SOURCE3} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png

# legacy menu entry
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Development/%{name}.desktop


%clean
rm -rf $RPM_BUILD_ROOT


%post
cd %{appdir}/lib \
&& ln -sf %{_javadir}/antlr.jar \
&& ln -sf %{_javadir}/dresden-ocl-argo.jar \
&& ln -sf %{_javadir}/gef.jar \
&& ln -sf %{_javadir}/log4j.jar \
&& ln -sf %{_javadir}/nsuml.jar \
&& ln -sf %{_javadir}/xml-commons-apis.jar \
&& ln -sf %{_javadir}/i18n-lib.jar
 
%postun
# remove links only if uninstalling
if [ $1 -eq 0 ]; then
  cd %{appdir}/lib \
  && rm -f antlr.jar \
  && rm -f dresden-ocl-argo.jar \
  && rm -f gef.jar \
  && rm -f log4j.jar \
  && rm -f nsuml.jar \
  && rm -f xml-commons-apis.jar \
  && rm -f i18n-lib.jar
fi


%post mdkmenu
%update_menus
 
%postun mdkmenu
%clean_menus

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  rm -f %{_javadocdir}/%{name}
fi


%files
%defattr(-,root,root,-)
%doc src_new/README_database.sql src_new/README.txt src_new/*LICENSE.txt
%{_bindir}/*
%{appdir}
%{_datadir}/applications/*-%{name}.desktop
%{_datadir}/icons/*/*/apps/*
%{_datadir}/pixmaps/%{name}.png

%files mdkmenu
%defattr(-,root,root,-)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files legacymenu
%defattr(-,root,root,-)
%{_sysconfdir}/X11/applnk/Development/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}


%changelog
* Fri Aug 29 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.14-1jpp
- Update to 0.14.
- More JPackage 1.5 updates.
- Include freedesktop.org menu entry in main package.
- Add non-versioned javadoc dir symlinks.

* Sat Apr 12 2003 David Walluck <david@anti-microsoft.org> 0:0.13.3-4jpp
- fix Patch1 and log4j configurations

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:0.13.3-3jpp
- more JPackage 1.5 updates
- multi-user fixes
- require xml-commons-apis for XML support

* Sun Apr 06 2003 David Walluck <david@anti-microsoft.org> 0:0.13.3-2jpp
- rebuild for JPackage 1.5
- no more bzip2 by popular demand

* Thu Mar 13 2003 Guillaume Rousse <guillomovitch@zarb.org> 0.13.3-1jpp
- 0.13.3

* Thu Feb 13 2003 Guillaume Rousse <guillomovitch@zarb.org> 0.13.2-1jpp
- 0.13.2 
- log4j patch merged upstream

* Mon Dec 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.13.1-1jpp
- 0.13.1
- regenerated patches

* Mon Oct 21 2002 David Walluck <david@anti-microsoft.org> 0.12-3jpp
- revert back to requiring gef >= 0.9.6

* Mon Oct 21 2002 David Walluck <david@anti-microsoft.org> 0.12-2jpp
- add %%gef_version macro
- require latest gef rpm
- change 'ln -s' to 'ln -sf'

* Fri Oct 17 2002 David Walluck <david@anti-microsoft.org> 0.12-1jpp
- 0.12
- bzip2 sources
- require jdepend (may not be needed now, but needed for CVS versions)
- rediff build patch

* Mon Oct 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.11.4-1jpp
- update from David Walluck <david@anti-microsoft.org>
 - 0.11.4
 - experimental log4j patch
- only remove symlinks if uninstalling, not upgrading

* Sun Sep  8 2002 Ville Skyttä <ville.skytta at iki.fi> 0.10.1-2jpp
- Add Red Hat menu item.
- Menu packages require main package.
- Fix menu entries' descriptions.
- Changed License to BSD.
- Use full URL to source tarball.

* Fri Sep 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.10.1-1jpp
- 0.10.1 
- new application policy

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.9-2jpp 
- hardcoded distribution and vendor tag
- group tag again

* Mon May 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.9-1jpp
- 0.9.9
- source system prefs in launch script
- inactivated jikes building

* Thu May 2 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.8-2jpp 
- distribution tag
- group tag
- source user prefs before configuration in launch script

* Tue Apr 09 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.8-1jpp
- 0.9.8

* Wed Mar 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.7-1jpp
- 0.9.7
- patch merged upstream

* Mon Mar 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.6-2jpp
- requires jaxp_parser2 instead of xerces-j1
- buildrequires ant >= 1.4.1-9jpp
- applied npe-fix.patch
- dropped xerces-j2 workaround

* Wed Mar 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.6-1jpp
- 0.9.6
- used png for icons
- section macro
- requires gef >= 0.9.6
- no more version dependecy on dresden-ocl
- no more dependency on log4j as gef already depends on it
- fixed missing macros for mdkmenu package

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-3jpp
- merged mdk and jpp branches
- additional sources in individual archives

* Fri Jan 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-2jpp
- requires antlr
- requires xerces-j1 instead of jaxp_parser (doesn't work with crimson)
- requires gef >= 0.9.5-5jpp as parasite class-path reference in manifest make crimson loading first
- corrected launch script
- javadoc in %{_datadir}/javadoc

* Tue Jan 8 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-1jpp
- 0.9.5
- requires log4j
- buildrequires log4j, junit and antlr
- javadoc package

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-8jpp
- Requires jpackage-utils

* Sat Dec 1 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-7jpp
- new launch script using functions library

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-6jpp
- used original tarball
- build patch for ant 1.4
- recreated source patch

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-5jpp
- more macros

* Fri Sep 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-4jpp
- first unified JPackage release
- GEF is now gef
- only dresden-ocl-argo is required
- unified launch script
- no more classpath in manifest
- s/jPackage/JPackage

* Thu Sep 13 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-3mdk
- menu entry
- used lower case for name
- spec cleanup

* Sat Jul 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-2mdk
- requires jaxp_parser
- use jaxp_parser alternative

* Sat Jun 23 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-1mdk
- first Mandrake release
